<?php

function append_city_url($url, $city) {

	if(!empty($city)) {
		return str_replace(get_site_url(),get_site_url().'/'.$city,$url);
	}else{
		if(isset($_COOKIE['geo_city'])) {
			$city = $_COOKIE['geo_city'];
			return str_replace(get_site_url(),get_site_url().'/'.$city,$url);
		}
		return $url;
	}

}

function get_cities($limit='') {

	if(empty($limit)) {
		$limit = '&posts_per_page=-1';
	}

	$query = new WP_Query('post_type=cities&post_status=publish&order_by=title'.$limit);
	if(count($query->posts)>0) {
		return $query->posts;
	}
	return false;

}

function check_city() {

	$city = unserialize(file_get_contents('http://www.geoplugin.net/php.gp?ip='.$_SERVER['REMOTE_ADDR']));

	if($city['geoplugin_city']) {
		$query = new WP_Query('post_type=cities&posts_per_page=1&post_status=publish&meta_key=city_eng&meta_value='.$city['geoplugin_city']);
		if(count($query->posts)>0) {
			return [
				'city_name'=>$query->posts[0]->post_title,
				'city_slug'=>$query->posts[0]->post_name
			];
		}else{
			$query = new WP_Query('post_type=cities&posts_per_page=1&post_status=publish');
			return [
				'city_name'=>$query->posts[0]->post_title,
				'city_slug'=>$query->posts[0]->post_name
			];
		}
	}else{
		$query = new WP_Query('post_type=cities&posts_per_page=1&post_status=publish');
			return [
				'city_name'=>$query->posts[0]->post_title,
				'city_slug'=>$query->posts[0]->post_name
			];
	}

}

add_action('wp_ajax_nopriv_show_city_question', 'show_city_question');
add_action('wp_ajax_show_city_question', 'show_city_question');
function show_city_question() {


	if(!isset($_COOKIE['geo_city']) && !isset($_COOKIE['nogeo']) && !get_query_var('geo_city')) {
		$city = check_city();
		$back_url = $_POST['back_url'];

		if(file_exists(get_template_directory() . '/belingoGeo/question_city.php')) {
			include_once( get_template_directory() . '/belingoGeo/question_city.php' );
		}else{
			include_once( WP_PLUGIN_DIR . '/belingoGeo/templates/question_city.php' );
		}
	}

	wp_die();

}

add_action('wp_ajax_nopriv_get_widget_city', 'get_widget_city');
add_action('wp_ajax_get_widget_city', 'get_widget_city');
function get_widget_city() {
	global $cityObj;

	if(isset($cityObj->posts[0]->post_title)) {
		echo $cityObj->posts[0]->post_title;
		wp_die();
	}

	echo get_option('belingo_geo_basic_default_nonecity');
	wp_die();

}

add_action('wp_ajax_nopriv_write_city_cookie', 'write_city_cookie');
add_action('wp_ajax_write_city_cookie', 'write_city_cookie');
function write_city_cookie() {

	if(isset($_COOKIE['nogeo'])) {
		unset($_COOKIE['nogeo']);
		setcookie('nogeo', 1, time()-1209600, COOKIEPATH, COOKIE_DOMAIN, false);
	}
	setcookie('geo_city', $_POST['city_name'], time()+1209600, COOKIEPATH, COOKIE_DOMAIN, false);

	wp_die();

}

add_action('wp_ajax_nopriv_write_nogeo_cookie', 'write_nogeo_cookie');
add_action('wp_ajax_write_nogeo_cookie', 'write_nogeo_cookie');
function write_nogeo_cookie() {

	if(isset($_COOKIE['geo_city'])) {
		$city_name = $_COOKIE['geo_city'];
		unset($_COOKIE['geo_city']);
		setcookie('geo_city', $city_name, time()-1209600, COOKIEPATH, COOKIE_DOMAIN, false);
	}
	setcookie('nogeo', 1, time()+1209600, COOKIEPATH, COOKIE_DOMAIN, false);

	wp_die();

}

add_action( 'wp_enqueue_scripts', 'belingo_ajax_data', 99 );
function belingo_ajax_data(){

	if(isset($_COOKIE['geo_city'])) {
        $back_url = str_replace('/'.$_COOKIE['geo_city'],'',$_SERVER['REQUEST_URI']);
    }else{
        $back_url = $_SERVER['REQUEST_URI'];
    }

	wp_localize_script( 'belingo-geo-scripts', 'belingoGeo',
		array(
			'ajaxurl' => admin_url('admin-ajax.php'),
			'homeurl' => home_url(),
			'backurl' => $back_url,
			'disable_urls' => get_option('belingo_geo_basic_disable_url')
		)
	);

}

add_action( 'wp_enqueue_scripts', 'belingo_geo_scripts' );
function belingo_geo_scripts() {
	wp_enqueue_script('belingo-geo-scripts', '/wp-content/plugins/belingoGeo/js/belingoGeo.js', array('jquery'), '', false);
}

add_filter( 'woocommerce_get_breadcrumb', 'belingoGeo_breadcrumb_hook', 10, 2 );
function belingoGeo_breadcrumb_hook($crumbs, $obj) {

	if(get_query_var('geo_city')) {
		$city_crumbs = [];
		foreach ($crumbs as $key => $crumb) {
			if($key == 1) {
				$city_crumbs[] = [
					do_shortcode('[city_query_var]'),
					get_permalink( woocommerce_get_page_id( 'shop' ) )
				];
			}
			$city_crumbs[] = $crumb;
		}
		$crumbs = $city_crumbs;
	}

	return $crumbs;

}

// Добавление новых sitemap в Yaost SEO Sitemap
add_filter('wpseo_sitemap_index', 'modify_yaost_sitemap');
function modify_yaost_sitemap() {

	$xml = '';

	foreach (get_cities() as $city) {
		$url = [
			"loc" => get_site_url() . '/'.$city->post_name.'_sitemap.xml',
			"lastmod" => date('c',time())
		];
		$xml .= get_xml_sitemap($url);
	}

	return $xml;

}

// filter on add do_shortcode for og:url
// filter on add city in canonical
add_filter('wpseo_opengraph_url', 'wpseo_opengraph_urls' );
add_filter('wpseo_canonical', 'wpseo_opengraph_urls');
function wpseo_opengraph_urls($u) {
	if(!is_front_page() && get_query_var('geo_city')) {
		return append_city_url($u, get_query_var('geo_city'));
	}else{
		return $u;
	}
}

function rewrite_rules_func() {
	rewrite_rules();
	init_city();
	flush_rewrite_rules();
}

function rewrite_rules() {

	$disable_urls = get_option('belingo_geo_basic_disable_url');

	if($disable_urls && $disable_urls == 1) {
		return;
	}

	$cities = [];
	$cities_query = new WP_Query('post_type=cities&posts_per_page=-1&post_status=publish');
	foreach ($cities_query->posts as $city) {
		$cities[] = $city->post_name;

		// sitemaps
		add_rewrite_rule('^('.$city->post_name.')_sitemap\.xml$', 'index.php?city_sitemap=$matches[1]', 'top');


	}

	foreach ($cities as $city) {

		// front page
		//add_rewrite_rule('^/('.$city.')/$', 'index.php?geo_city=$matches[1]', 'top');

		$brand_base = get_option('belingo_geo_basic_brand_base');
		$brand_term = get_option('belingo_geo_basic_brand_term');

		if(class_exists('WooCommerce')) {
			$wc_struct = wc_get_permalink_structure();
			add_rewrite_rule('^('.$city.')/'.$wc_struct['tag_base'].'/(.*)/page/([0-9]*)/?', 'index.php?product_tag=$matches[2]&paged=$matches[3]&geo_city=$matches[1]', 'top');
			add_rewrite_rule('^('.$city.')/'.$wc_struct['tag_base'].'/(.*)/?', 'index.php?product_tag=$matches[2]&geo_city=$matches[1]', 'top');
			add_rewrite_rule('^('.$city.')/'.$wc_struct['category_base'].'/(.*)/page/([0-9]*)/?', 'index.php?product_cat=$matches[2]&paged=$matches[3]&geo_city=$matches[1]', 'top');
			add_rewrite_rule('^('.$city.')/'.$wc_struct['category_base'].'/(.*)/?', 'index.php?product_cat=$matches[2]&geo_city=$matches[1]', 'top');
			add_rewrite_rule('^('.$city.')'.$wc_struct['product_base'].'/([^/]*)/?', 'index.php?product=$matches[2]&geo_city=$matches[1]', 'top');

			if($brand_base && $brand_term && !empty($brand_base) && !empty($brand_term)) {
				add_rewrite_rule('^('.$city.')/'.$brand_base.'/(.*)/?', 'index.php?'.$brand_term.'=$matches[2]&geo_city=$matches[1]', 'top');
			}

		}

	}

	if(empty(get_option('category_base'))) {
		$category_base = 'category';
	}else{
		$category_base = get_option('category_base');
	}

	$arr_terms_exclude = get_option('belingo_geo_exclude_terms');
	$terms = get_terms(array(
		'taxonomy' => 'category',
		'exclude' => $arr_terms_exclude
	));
	foreach ($terms as $term) {
		foreach ($cities as $city) {
			add_rewrite_rule('^('.$city.')/'.$category_base.'/('.$term->slug.')/page/([0-9]*)/?', 'index.php?taxonomy=category&term=$matches[2]&paged=$matches[3]&geo_city=$matches[1]', 'top');
			add_rewrite_rule('^('.$city.')/'.$category_base.'/('.$term->slug.')/?', 'index.php?taxonomy=category&term=$matches[2]&geo_city=$matches[1]', 'top');
		}
	}

	$arr_posts_exclude = get_option('belingo_geo_exclude_posts');
	$posts = new WP_Query(array(
		'post_type'		=>	'post',
		'posts_per_page'=>	-1,
		'post_status'	=>	'publish',
		'post__not_in'	=>	$arr_posts_exclude,
		'category__not_in' => $arr_terms_exclude
	));
	foreach ($posts->posts as $post_item) {
		if(!empty($post_item->post_name)) {
			foreach ($cities as $city) {
				$slug = trim(str_replace(home_url(), '', get_permalink($post_item->ID)),'/');
				add_rewrite_rule('^('.$city.')/('.$slug.')/?', 'index.php?name=$matches[2]&geo_city=$matches[1]', 'top');
			}
		}
	}

	$arr_pages_exclude = get_option('belingo_geo_exclude_pages');
	$pages = new WP_Query(array(
		'post_type'		=>	'page',
		'posts_per_page'=>	-1,
		'post_status'	=>	'publish',
		'post__not_in'	=>	$arr_pages_exclude
	));
	if(class_exists('WooCommerce')) {
		$shop_page_id = wc_get_page_id( 'shop' );
	}else{
		$shop_page_id = 0;
	}
	foreach ($pages->posts as $page_item) {
		if(!empty($page_item->post_name)) {
			foreach ($cities as $city) {
				$slug = trim(str_replace(home_url(), '', get_permalink($page_item->ID)),'/');
				if($shop_page_id != $page_item->ID) { 
					add_rewrite_rule('^('.$city.')/('.$slug.')/?', 'index.php?pagename=$matches[2]&geo_city=$matches[1]', 'top');
				}else{
					add_rewrite_rule('^('.$city.')/('.$slug.')/?', 'index.php?post_type=product&geo_city=$matches[1]', 'top');
					add_rewrite_rule('^('.$city.')/('.$slug.')/feed/(feed|rdf|rss|rss2|atom)/?', 'index.php?post_type=product&feed=$matches[3]&geo_city=$matches[1]', 'top');
					add_rewrite_rule('^('.$city.')/('.$slug.')/(feed|rdf|rss|rss2|atom)/?', 'index.php?post_type=product&feed=$matches[3]&geo_city=$matches[1]', 'top');
					add_rewrite_rule('^('.$city.')/('.$slug.')/page/([0-9]{1,})/?', 'index.php?post_type=product&paged=$matches[3]&geo_city=$matches[1]', 'top');
				}
			}
		}
	}

}

function city_url_redirect() {
	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city')) {
		$city_url = append_city_url(get_site_url().$_SERVER['REQUEST_URI'], $_COOKIE['geo_city']);
		Header("Location: ".$city_url);
		exit;
	}
}

function init_cityObj() {
	global $cityObj;

	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city')) {
		$geo_city = $_COOKIE['geo_city'];
		$cityObj = new WP_Query('post_type=cities&name='.$geo_city);
	}
	if(!isset($_COOKIE['geo_city']) && get_query_var('geo_city')) {
		$geo_city = get_query_var('geo_city');
		$cityObj = new WP_Query('post_type=cities&name='.$geo_city);
	}
	if(isset($_COOKIE['geo_city']) && get_query_var('geo_city')) {
		$geo_city = get_query_var('geo_city');
		$cityObj = new WP_Query('post_type=cities&name='.$geo_city);
	}

}

function init_city() {

	init_cityObj();
	
	$arr_pages_exclude = get_option('belingo_geo_exclude_pages');
	$arr_posts_exclude = get_option('belingo_geo_exclude_posts');
	$arr_terms_exclude = get_option('belingo_geo_exclude_terms');
	$disable_urls = get_option('belingo_geo_basic_disable_url');

	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city') && !$disable_urls) {
		if(!is_front_page()) {
			if(is_page()) {
				if(!in_array(get_the_ID(), (array)$arr_pages_exclude)) {
					city_url_redirect();
				}
			}
			if(is_single()) {
				if(!in_array(get_the_ID(), (array)$arr_posts_exclude)) {
					city_url_redirect();
				}
			}
			if(is_category()) {
				$catID = get_the_category();
				if(!in_array($catID[0]->term_id, (array)$arr_terms_exclude)) {
					city_url_redirect();
				}
			}
			if(class_exists('WooCommerce')) {
				if(is_product_category() || is_product()) {
					city_url_redirect();
				}
			}
		}
	}

	if(get_query_var('geo_city') && !$disable_urls) {
		if(get_query_var('geo_city')) {
			$geo_city = get_query_var('geo_city');
		}

		add_filter( 'page_link', function(  $url, $post_id ) {
			global $geo_city, $arr_pages_exclude;
			if(in_array($post_id, (array)$arr_pages_exclude)) {
				return $url;
			}else{
				return append_city_url($url, $geo_city);
			}
		}, 10, 2 );
		add_filter( 'post_link', function(  $url, $post ) {
			global $geo_city, $arr_posts_exclude, $arr_terms_exclude;
			$clean_url = false;
			$post_terms = wp_get_post_terms($post->ID, 'category', array('fields'=>'ids'));
			foreach ($post_terms as $post_term) {
				if(in_array($post_term, (array)$arr_terms_exclude)) {
					$clean_url = true;
				}
			}
			if(in_array($post->ID, (array)$arr_posts_exclude) || $clean_url == true) {
				return $url;
			}else{
				return append_city_url($url, $geo_city);
			}
		}, 10, 2 );

		add_filter( 'term_link', function(  $url, $term ) {
			global $geo_city, $arr_terms_exclude;
			if(in_array($term->term_id, (array)$arr_terms_exclude)) {
				return $url;
			}else{
				return append_city_url($url, $geo_city);
			}
		}, 10, 2 );
		add_filter( 'post_type_link', function(  $url ) { global $geo_city; return append_city_url($url, $geo_city); }, 10, 1 );
	}

	if(get_query_var('geo_city') && !isset($_COOKIE['geo_city'])) {
		if(isset($_COOKIE['nogeo'])) {
			unset($_COOKIE['nogeo']);
			setcookie('nogeo', 1, time()-1209600, COOKIEPATH, COOKIE_DOMAIN, false);
		}
		setcookie('geo_city', get_query_var('geo_city'), time()+1209600, COOKIEPATH, COOKIE_DOMAIN, false);
	}

	if(get_query_var('city_sitemap')) {
		$city = get_query_var('city_sitemap');
		$urls = get_sitemap_urls($city);
		get_xml($urls);
		exit;
	}

}

?>
