<?php

add_shortcode("city", "city_shortcode");
function city_shortcode() {
	global $cityObj;

	if(isset($_COOKIE['geo_city'])) {
		return $cityObj->posts[0]->post_title;
	}
	if(!isset($_COOKIE['geo_city']) && get_query_var('geo_city')) {
		return $cityObj->posts[0]->post_title;
	}
	return '';
}

add_shortcode("widget_city", "widget_city_shortcode");
function widget_city_shortcode() {
	global $cityObj;

	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city')) {
		return $cityObj->posts[0]->post_title;
	}
	if(get_query_var('geo_city')) {
		return $cityObj->posts[0]->post_title;
	}
	return get_option('belingo_geo_basic_default_nonecity');
}

add_shortcode("city_query_var", "city_query_var_shortcode");
function city_query_var_shortcode() {
	global $cityObj;

	if(get_query_var('geo_city')) {
		return $cityObj->posts[0]->post_title;
	}
	return '';
}

add_shortcode("city_padej1", "city_padej1_shortcode");
function city_padej1_shortcode() {
	global $cityObj;

	if(get_query_var('geo_city')) {
		return get_post_meta($cityObj->posts[0]->ID,'city_padej1',true);
	}
	return '';
}

add_shortcode("city_padej2", "city_padej2_shortcode");
function city_padej2_shortcode() {
	global $cityObj;

	if(get_query_var('geo_city')) {
		return get_post_meta($cityObj->posts[0]->ID,'city_padej2',true);
	}
	return '';
}

add_shortcode("city_padej3", "city_padej3_shortcode");
function city_padej3_shortcode() {
	global $cityObj;

	if(get_query_var('geo_city')) {
		return get_post_meta($cityObj->posts[0]->ID,'city_padej3',true);
	}
	return '';
}

add_shortcode("city_phone", "city_phone_shortcode");
function city_phone_shortcode() {
	global $cityObj;

	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city')) {
		$phone = get_post_meta($cityObj->posts[0]->ID,'city_phone',true);
	}
	if(get_query_var('geo_city')) {
		$phone = get_post_meta($cityObj->posts[0]->ID,'city_phone',true);
	}
	if(!isset($phone) || empty($phone)) {
		$phone = get_option('belingo_geo_basic_default_phone');
	}
	return $phone;
}

add_shortcode("city_address", "city_address_shortcode");
function city_address_shortcode() {
	global $cityObj;

	if(isset($_COOKIE['geo_city']) && !get_query_var('geo_city')) {
		$address = get_post_meta($cityObj->posts[0]->ID,'city_address',true);
	}
	if(get_query_var('geo_city')) {
		$address = get_post_meta($cityObj->posts[0]->ID,'city_address',true);
	}
	if(!isset($address) || empty($address)) {
		$address = get_option('belingo_geo_basic_default_address');
	}
	return $address;
}

add_shortcode("cities_addon_contacts", "cities_addon_contacts_shortcode");
function cities_addon_contacts_shortcode() {
	global $cityObj;

	if(get_query_var('geo_city')) {
		$geo_city = get_query_var('geo_city');
		$city_addon_contacts = json_decode(get_post_meta($cityObj->posts[0]->ID,'city_addon_contacts',true));

		foreach ($city_addon_contacts as $key => $value) {
			$result[] = [
				"addon_contact_name" => base64_decode($value->addon_contact_name),
				"addon_contact_phone" => base64_decode($value->addon_contact_phone),
				"addon_contact_address" => base64_decode($value->addon_contact_address),
				"addon_contact_time" => base64_decode($value->addon_contact_time)
			];
		}

		ob_start();

		if(file_exists(get_template_directory() . '/belingoGeo/cities_addon_contacts.php')) {
			include_once( get_template_directory() . '/belingoGeo/cities_addon_contacts.php' );
		}else{
			include_once( WP_PLUGIN_DIR . '/belingoGeo/templates/cities_addon_contacts.php' );
		}

		$result = ob_get_contents();
		ob_end_clean();
		
		return $result;

	}
	return '';
}

add_filter('the_title', 'belingo_the_title', 99, 2);
function belingo_the_title( $title, $id = null) {

	$title = str_replace('[city]', do_shortcode('[city]'), $title);
	$title = str_replace('[city_padej1]', do_shortcode('[city_padej1]'), $title);
	$title = str_replace('[city_padej2]', do_shortcode('[city_padej2]'), $title);
	$title = str_replace('[city_padej3]', do_shortcode('[city_padej3]'), $title);
	$title = str_replace('[city_phone]', do_shortcode('[city_phone]'), $title);
	$title = str_replace('[city_address]', do_shortcode('[city_address]'), $title);
	
	return $title;

}

add_filter('wp_title', 'belingo_city_title', 99, 3);
function belingo_city_title($title, $sep, $seplocation) {

	$title = str_replace('[city]', do_shortcode('[city]'), $title);
	$title = str_replace('[city_padej1]', do_shortcode('[city_padej1]'), $title);
	$title = str_replace('[city_padej2]', do_shortcode('[city_padej2]'), $title);
	$title = str_replace('[city_padej3]', do_shortcode('[city_padej3]'), $title);
	$title = str_replace('[city_phone]', do_shortcode('[city_phone]'), $title);
	$title = str_replace('[city_address]', do_shortcode('[city_address]'), $title);

	return $title;
}

add_filter('wpseo_metadesc', 'belingo_city_meta', 99);
add_filter('wpseo_metakeywords', 'belingo_city_meta', 99);
add_filter('wpseo_title', 'belingo_city_meta', 99);
add_filter('wpseo_opengraph_desc', 'belingo_city_meta', 99);
add_filter('wpseo_opengraph_title', 'belingo_city_meta', 99);

function belingo_city_meta($s) {

	$s = str_replace('[city]', do_shortcode('[city]'), $s);
	$s = str_replace('[city_padej1]', do_shortcode('[city_padej1]'), $s);
	$s = str_replace('[city_padej2]', do_shortcode('[city_padej2]'), $s);
	$s = str_replace('[city_padej3]', do_shortcode('[city_padej3]'), $s);
	$s = str_replace('[city_phone]', do_shortcode('[city_phone]'), $s);
	$s = str_replace('[city_address]', do_shortcode('[city_address]'), $s);

	return $s;

}

add_shortcode("select_city", "select_city_shortcode");
function select_city_shortcode() {
 	if(file_exists(get_template_directory() . '/belingoGeo/select_city.php')) {
		include_once( get_template_directory() . '/belingoGeo/select_city.php' );
	}else{
		include_once( WP_PLUGIN_DIR . '/belingoGeo/templates/select_city.php' );
	}
}

?>